/*
 * Prototypes
 */

scoreboard * get_scoreboard(int shmid);
const char * add_mp3_accept(cmd_parms *cmd, void *mconfig, char *value);
const char * add_mp3_deny(cmd_parms *cmd, void *mconfig, char *value);
const char * set_limit_connections(cmd_parms *cmd, void *mconfig, char *value);
const char * add_default_op(cmd_parms *cmd, void *mconfig, char *param, char *type);
const char * add_log(cmd_parms *cmd, void *mconfig, char *filename);
const char * add_mp3(cmd_parms *cmd, void *mconfig, char *param);
const char * add_stream(cmd_parms *cmd, void *mconfig, char *param);
const char * add_mp3_playlist(cmd_parms *cmd, void *mconfig, char *param);
const char * enable_cache(cmd_parms *cmd, void *mconfig, int flag);
FILE *open_content(request_rec* r, mp3_conf* cfg, mp3_data* content);
void send_icecast_headers(request_rec *r, mp3_conf* cfg, request_data *request);
const char * get_udp_message(pool *p, const char *name, const char *artist, const char *url, const char *title);
void send_udp_message(request_rec *r, int port, const char *message);
int get_id3_tag(pool *p, int fd, mp3_data *bank);
void * internal_create(pool *p);
int internal_request(void *info, pool *p);
mp3_data * internal_get(void *info, pool *p, char *filename);
int internal_set(void *info, pool *p, mp3_data *file);
mp3_data * internal_random(void *info, pool *p);
array_header * internal_search(void *info, pool *p, const char *pattern, int limit);
mp3_data * mp3_create_content(pool *p, char *filename, char *name, int flag);
int load_playlist(pool *p, mp3_conf *cfg, char *file, int cache_enabled);
int load_file(pool *p, mp3_conf *cfg, char *file, char *name, int cache_enabled);
int load_directory(pool *p, mp3_conf *cfg, char *param);
void write_log(request_rec *r, mp3_conf *cfg, request_data *info, mp3_data *bank);
const char * add_dispatch_agent(cmd_parms *cmd, void *mconfig, char *type);
void * mysql_create(pool *p);
void mysql_cleanup(void *data);
int mysql_request(void *info, pool *p);
mp3_data * mysql_get(void *info, pool *p, char *signature);
int mysql_set(void *info, pool *p, mp3_data *bank);
mp3_data * mysql_each(void *info, pool *p, array_header *files, const char *token);
mp3_data * mysql_random(void *info, pool *p);
array_header * mysql_search(void *info, pool *p, const char *pattern, int limit);
const char * mysql_add_connect_info(cmd_parms *cmd, void *mconfig, char *hostname, char *user, char *password);
const char * mysql_add_database_info(cmd_parms *cmd, void *mconfig, char *database, char *table);
const char * mysql_add_token_table(cmd_parms *cmd, void *mconfig, char *table);
void send_ogg_headers(request_rec *r, mp3_conf* cfg, request_data *request);
void * pgsql_create(pool *p);
void pgsql_cleanup(void *data);
int pgsql_request(void *info, pool *p);
mp3_data * pgsql_get(void *info, pool *p, char *signature);
int pgsql_set(void *info, pool *p, mp3_data *bank);
mp3_data * pgsql_each(void *info, pool *p, array_header *files);
mp3_data * pgsql_random(void *info, pool *p);
const char * pgsql_add_connect_info(cmd_parms *cmd, void *mconfig, char *hostname, char *user, char *password);
const char * pgsql_add_database_info(cmd_parms *cmd, void *mconfig, char *database, char *table);
void send_shout_headers(request_rec *r, mp3_conf* cfg, request_data *request);
int shout_write(request_rec *r, unsigned char c, const char *title, const char *artist, const char *url, int *flag);
int mp3_match(const char *s1, const char *s2);
char * escape_xml(pool *p, const char *s);
const char * make_basename(request_rec *r);
void cleanup_scoreboard(void *data);
void cleanup_file(void *data);
int register_connection(request_rec *r, mp3_server_conf *scfg, int limit, int type);
array_header * get_songs(pool *p, table * t);
table * parse_args(request_rec *r);
void table_list(char *string, table * t);
